/*******************************************************************************
 **
 ** Licensed Materials - Property of IBM
 **
 ** (C) COPYRIGHT International Business Machines Corp. 2000, 2001
 ** All Rights Reserved.
 **
 ******************************************************************************/
#include "CLPsplashview.h"
#include "SampleCLP.mbg"  // header for color/or mono multi-bitmaps

_LIT(KTxtCDrive,"C:");
_LIT(KTxtZDrive,"Z:");
_LIT(KTxtName,"\\system\\apps\\SampleCLP\\SampleCLP.mbm");

void CCLPSplashView::ConstructL(const TRect& aRect)
{
  CreateWindowL();
  Window().SetShadowHeight(4);
  Window().SetShadowDisabled(ETrue);
  Window().SetCornerType(EWindowCornerSquare, 0); 
  SetRectL(aRect);
  CreateBitMapsL();
  ActivateL();
}

CCLPSplashView::~CCLPSplashView()
{
  delete iCLPabouti;
  delete iCLPaboutm;
}

void CCLPSplashView::LoadBitmapL(CFbsBitmap* aBitMap,const TDesC& aPathAndFile,TInt aId,TBool aShareIfLoaded)
{
  TParse mbfn;
  
  mbfn.Set(aPathAndFile,&KTxtCDrive,NULL);
  if (!aBitMap->Load(mbfn.FullName(),aId,aShareIfLoaded))
    return;

  mbfn.Set(aPathAndFile,&KTxtZDrive,NULL);
  User::LeaveIfError(aBitMap->Load(mbfn.FullName(),aId,aShareIfLoaded));
  return;
}

void CCLPSplashView::CreateBitMapsL()
{
  TBool shareIfLoaded(ETrue);

  iCLPabouti = new (ELeave) CFbsBitmap();
  LoadBitmapL(iCLPabouti,KTxtName,EMbmSampleCLPCLPabouti,shareIfLoaded);    
  iCLPaboutm = new (ELeave) CFbsBitmap();
  LoadBitmapL(iCLPaboutm,KTxtName,EMbmSampleCLPCLPaboutm,shareIfLoaded);
}

TInt CCLPSplashView::CountComponentControls() const
{
  return 0;
}

void CCLPSplashView::Draw(const TRect& aRect) const
{
  CWindowGc& gc = SystemGc();
  // Clear the application view
  gc.Clear();
  // Draw a rectangle round the edge of the application view.
  TRect iRect=aRect;
  gc.BitBltMasked(TPoint(0,0), iCLPabouti, iRect, iCLPaboutm, ETrue);
}
