@echo off
REM ****************************************************
REM **                                                **
REM **  Build.bat - build script for CLP application  **
REM **                                                **
REM ****************************************************

setlocal

REM ----------------------------------------
REM --  Specification of the application  --
REM ----------------------------------------

set _appname_=SampleCLP
set _errcode_=0

REM ------------
REM --  Menu  --
REM ------------

if "%1"=="" goto help
if "%1"=="icn" goto icn
if "%1"=="mbg" goto mbg
if "%1"=="aif" goto aif
if "%1"=="hlp" goto hlp
if "%1"=="make" goto make
if "%1"=="compile" goto compile
if "%1"=="install" goto install
if "%1"=="all" goto all
if "%1"=="clean" goto clean

if "%3"=="" goto help

goto help



:icn
echo **********************************************************
echo ***               creating icn file                    ***
echo **********************************************************

if "%2" == "" goto help

pushd Src\Icon
call iconbuild %2
set _errcode_=%errorlevel%
popd

REM -- ERROR HANDLING --
set _err_=CREATING icn file
if not %_errcode_%==0 goto ERROR
REM -- MESSAGE --
set _msg_=CREATING icn file

goto END



:mbg
echo *********************************************************
echo ***   Creating .mbm and .mbg file for splash Screen   ***
echo *********************************************************

if "%2" == "" goto help

pushd Src\Images

del ..\%_appname_%.mbg > NUL 2>&1
del %_appname_%.mbm > NUL 2>&1
del \epoc32\release\wins\rel\z\system\apps\%_appname_%\%_appname_%.mbm > NUL 2>&1
del \epoc32\release\wins\deb\z\system\apps\%_appname_%\%_appname_%.mbm > NUL 2>&1
del ..\wins\%_appname_%.mbm > NUL 2>&1
del ..\marm\%_appname_%.mbm > NUL 2>&1

call bmconv /h..\%_appname_%.mbg %_appname_%.mbm /c16%2\CLPabouti.bmp /1mask\CLPaboutm.bmp
echo f | xcopy /q %_appname_%.mbm \epoc32\release\wins\rel\z\system\apps\%_appname_%\%_appname_%.mbm
echo f | xcopy /q %_appname_%.mbm \epoc32\release\wins\deb\z\system\apps\%_appname_%\%_appname_%.mbm
echo f | xcopy /q %_appname_%.mbm ..\..\wins\%_appname_%.mbm
echo f | xcopy /q %_appname_%.mbm ..\..\marm\%_appname_%.mbm
del %_appname_%.mbm

popd

goto END



:aif
echo **********************************************************
echo ***               creating aif file                    ***
echo **********************************************************

pushd Src\Icon

del \epoc32\release\wins\rel\z\system\apps\%_appname_%\%_appname_%.aif > NUL 2>&1
del \epoc32\release\wins\deb\z\system\apps\%_appname_%\%_appname_%.aif > NUL 2>&1
del \epoc32\release\marm\rel\%_appname_%.aif > NUL 2>&1
del \epoc32\release\marm\deb\%_appname_%.aif > NUL 2>&1

call aiftool %_appname_%  %_appname_%.icn
echo f | xcopy /q %_appname_%.aif ..\..\%2\%_appname_%.aif
echo f | xcopy /q %_appname_%.aif \epoc32\release\wins\rel\z\system\apps\%_appname_%\%_appname_%.aif
echo f | xcopy /q %_appname_%.aif \epoc32\release\wins\deb\z\system\apps\%_appname_%\%_appname_%.aif
echo f | xcopy /q %_appname_%.aif \epoc32\release\marm\rel\%_appname_%.aif
echo f | xcopy /q %_appname_%.aif \epoc32\release\marm\deb\%_appname_%.aif

popd

goto END



:make

if "%2" == "" goto help

echo *********************************
echo ***   creating the makefile   ***
echo *********************************
pushd Src

del %_appname_%.mmp > NUL 2>&1
del %_appname_%.WINS > NUL 2>&1
del %_appname_%.MARM > NUL 2>&1

for /f %%k in ('cd') do set _curdir_=%%~pnk\..
perl -pe "s/\bPROJECT\b.*$/PROJECT %_curdir_:\=\\%/" .\%_appname_%.ump > .\%_appname_%.mmp

call makmake -makework %_appname_% %2
call makmake %_appname_% %2

popd

goto END



:compile

if "%2"=="" goto help

echo **********************************************************
echo ***           compiling the resource file              ***
echo **********************************************************
pushd Src\Rsc 
call eikrs %_appname_% sc
popd


echo **********************************************************
echo ***           compiling the application                ***
echo **********************************************************
pushd Src

del ..\%2\%_appname_%.app > NUL 2>&1
del ..\%2\%_appname_%.rsc > NUL 2>&1

if "%2" == "marm" goto copymarm
if "%2" == "wins" goto copywins

:copymarm
del \epoc32\release\%2\rel\%_appname_%.app > NUL 2>&1
del \epoc32\release\%2\rel\%_appname_%.rsc > NUL 2>&1
call nmake -f %_appname_%.%2 rel
echo f | xcopy /q \epoc32\release\%2\rel\%_appname_%.app ..\%2\%_appname_%.app
echo f | xcopy /q \epoc32\release\%2\rel\%_appname_%.rsc ..\%2\%_appname_%.rsc
goto END

:copywins
del \epoc32\release\%2\rel\Z\System\Apps\%_appname_%\%_appname_%.app > NUL 2>&1
del \epoc32\release\%2\rel\Z\System\Apps\%_appname_%\%_appname_%.rsc > NUL 2>&1
call nmake -f %_appname_%.%2 rel
echo f | xcopy /q \epoc32\release\%2\rel\Z\System\Apps\%_appname_%\%_appname_%.app ..\%2\%_appname_%.app
echo f | xcopy /q \epoc32\release\%2\rel\Z\System\Apps\%_appname_%\%_appname_%.rsc ..\%2\%_appname_%.rsc
goto END



:install

rem -- no sis for wins --
if "%2" == "" goto help
if "%2" == "wins" goto END

echo **********************************************************
echo ***     building EPOC installation file (sis)          ***
echo **********************************************************

pushd Src

del ..\marm\%_appname_%.sis > NUL 2>&1
call makesis %_appname_%.pkg
move %_appname_%.sis ..\marm\%_appname_%.sis

popd

goto END



REM -----------------------------------------------------------
REM --  all - Do all in a sequence                           --
REM -----------------------------------------------------------
:all
if "%2" == "" goto help
if "%3" == "" goto help

call build icn %3
call build mbg %3
call build aif %2
call build make %2
call build compile %2
call build install %2
goto END



REM -----------------------------------------------------------
REM --  clean - Cleanup averything                           --
REM -----------------------------------------------------------
:clean

pushd src

call makmake -clean %_appname_% marm
call makmake -clean %_appname_% wins
rmdir /s /q \epoc32\release\wins\rel\Z\System\Apps\%_appname_%
rmdir /s /q \epoc32\release\wins\deb\Z\System\Apps\%_appname_%
rmdir /s /q ..\wins
rmdir /s /q ..\marm
del \epoc32\release\marm\rel\%_appname_%.*
del \epoc32\release\marm\deb\%_appname_%.*

del Icon\%_appname_%.icn
del %_appname_%.marm
del %_appname_%.wins
del Rsc\%_appname_%.rsc

popd

goto END



REM -------------------------------------
REM --  help - Syntax of the commands  --
REM -------------------------------------


:help
echo **********************************************************************
echo   Use this to build the %_appname_% application
echo   build icn [color]          build the .icn file for app icon
echo   build mbg [color]          build .mbm and .mbg file for splashview
echo   build aif [platform]       build the .aif file
echo   build make [platform]      build the MARM makefile
echo   build compile [platform]   compiles the project
echo   build install [platform]   creates the installation file 
echo                                for marm or installs the 
echo                                application for wins
echo   build all [platform] [color]     do all these steps in sequence
echo   build clean                      cleans up everything
echo **********************************************************************
goto END

:ERROR
echo ***********************************************************
echo *** ERROR %_err_%                        
echo ***********************************************************

:END
REM ---------------
REM --  THE END  --
REM ---------------

endlocal
