/*******************************************************************************
 **
 ** Licensed Materials - Property of IBM
 **
 ** (C) COPYRIGHT International Business Machines Corp. 2000, 2001
 ** All Rights Reserved.
 **
 ******************************************************************************/

#ifndef __CLPAPPUI_H__
#define __CLPAPPUI_H__

/******************************************************************************/
/** Includes                                                                 **/
/******************************************************************************/

#include <eikappui.h>
#include <eikfnlab.h>     // CEikFileNameLable
#include <eiktbar.h>      // CEikToolBar
#include <eikhopbt.h>     // horizontal option button list
#include <e32math.h>
#include <basched.h>
#include <s32std.h>
#include <coeutils.h>     // Cone Utilities
#include <apgtask.h>      // TApaTaskList , BringToForeground()
#include <apgwgnam.h>     // CApaWindowGroupName
#include <eikdll.h>       // EikDll
#include <f32file.h>      // TParse
#include <eikmenub.h>
#include <eikapp.h>
#include <eikbutb.h>
#include <eikdialg.h>     // Required for dialogs
#include <eikalert.h>     // Required for alert dialogs
#include <eikinfo.h>      // required for info dialogs
#include <eikgrid.h>
#include <eikedwin.h>     // text editors
#include <eikgted.h>
#include <txtglobl.h>     // global text
#include <eikseced.h>     // Secret Editor
#include "CLPsplashview.h"
#include "CLPview.h"
#include "CLPCommon.h"
#include "CLP.hrh"
#include <SampleCLP.rsg>
#include <eikon.rsg>
#include "CLPep.h"
#include <eikdoc.h>
#include <s32std.h>

/******************************************************************************/
/** Declaration of CLASSES                                                   **/
/******************************************************************************/

/******************************************************************************
  * The purpose of a document is to contain data for a particular instance of 
  * an application program. This includes all the data entered by the user.
  */

class CCLPAppUi : public CEikAppUi, public CCLPObserver
{
public:
  ~CCLPAppUi();
  void ConstructL();
  void ConstructSplashViewL();
  void ConstructClpViewL();
  virtual void HandleCommandL(TInt aCommand);
  void ResetSplashViewL();
  void ErrorNotify(const TInt aErrMessage, TInt aErrCode);
  void MessageNotify(const TInt aMessageType, const TInt aMessage);
  void print1_ep(SQLTCHAR* msg); // interface to print msg in SampleCLP

private: // internal functions
  void LaunchLoginDlgL();
  void SetNameLabelL();
  
private:
  TRect                 iRect;
  CCoeControl*          iAppView;
  TViewType             iViewType;
  CCLPSplashView*       iSplashView;
  CCLPView*             iClpView;
   
public:
  CCLPEng*              iCLPEng;

  TBuf<20>              iUsername;
  TBuf<20>              iPassword;
  TBuf<80>              iPathname;

  TBool                 iIsSplashView;
  TBool                 iShowIcon;
  TBool                 iDBdrive;

  CLPState*             iclpstate;
};

/******************************************************************************
  * The purpose of this class is to collect user information at login time 
  */

class CLoginDlg : public CEikDialog
{
  public:
    CLoginDlg(CCLPSplashView*   aSplashView,
              CCLPAppUi*        aAppUi,
              TRect             aRect);

    ~CLoginDlg();

  private: // framework
    TBool OkToExitL(TInt aButtonId /*TInt aKeycode*/);
    void PreLayoutDynInitL();

  private:
    CDesCArray*           itemArray;
    CCLPSplashView*       iSplashView;
    CCLPAppUi*            iAppUi;
    TRect                 iRect;
};

#endif // __CLPAPPUI_H__

