package java.sql;

/* 
 * Licensed Materials - Property of IBM,
 * (c) Copyright IBM Corp. 1998, 2000 All Rights Reserved
 */

import java.util.Calendar;

public class Date extends java.util.Date {

   

   public Date(long date)
   {
      super(date);
   }
	
   public void setTime(long date)
   {
      super.setTime(date);
   }

   public static Date valueOf(String s)
   {
      int posDelim1, posDelim2;
      int year, month, day;
      String errMsg = "Date must be of the form:  yyyy-mm-dd";
      
      if (s == null || (s.length() > "yyyy-mm-dd".length()))
         throw new java.lang.IllegalArgumentException(errMsg);

      posDelim1 = s.indexOf('-',0);
      posDelim2 = s.lastIndexOf('-');

      if ( (posDelim1 > 0) && (posDelim2 != s.length()-1) && ((posDelim2-posDelim1) > 1) )
      {
         year  = Integer.parseInt(s.substring(0, posDelim1));
         month = Integer.parseInt(s.substring(posDelim1+1, posDelim2));
         day   = Integer.parseInt(s.substring(posDelim2+1));
	   Calendar cal = Calendar.getInstance();
	   cal.set(Calendar.YEAR, year);
	   cal.set(Calendar.MONTH, month);
	   cal.set(Calendar.DAY_OF_MONTH, day);
	   java.util.Date aDate = cal.getTime();
	   return new java.sql.Date(aDate.getTime());
      }

      throw new java.lang.IllegalArgumentException(errMsg);
   }

   public String toString()
   {
   	Calendar cal = Calendar.getInstance();
   	cal.setTime(this);
      int year        = cal.get(Calendar.YEAR);
      int month       = cal.get(Calendar.MONTH);;
      int day         = cal.get(Calendar.DAY_OF_MONTH);
      String theYear  = Integer.toString(year);
      String theMonth = (month >= 10)? (Integer.toString(month)): ("0"+month);
      String theDay   = (day >= 10)? (Integer.toString(day)): ("0"+day);

      return ( theYear + "-" + theMonth + "-" + theDay );

   }

   public int getHours()
   {
      throw new java.lang.IllegalArgumentException();
   }

   public int getMinutes()
   {
      throw new java.lang.IllegalArgumentException();
   }

   public int getSeconds()
   {
      throw new java.lang.IllegalArgumentException();
   }

   public void setHours(int i)
   {
      throw new java.lang.IllegalArgumentException();
   }

   public void setMinutes(int i)
   {
      throw new java.lang.IllegalArgumentException();
   }

   public void setSeconds(int i)
   {
      throw new java.lang.IllegalArgumentException();
   }

}

