package java.sql;

/* 
 * Licensed Materials - Property of IBM,
 * (c) Copyright IBM Corp. 1998, 2000 All Rights Reserved
 */

import java.io.InputStream;
// import java.io.Reader;
// import java.math.BigDecimal;
// import java.util.Calendar;

public interface PreparedStatement extends Statement {

   public ResultSet executeQuery() throws SQLException;

   public int executeUpdate() throws SQLException;

   public void setNull(int parameterIndex, int sqlType) throws SQLException;

   public void setBoolean(int parameterIndex, boolean x) throws SQLException;

   public void setByte(int parameterIndex, byte x) throws SQLException;

   public void setShort(int parameterIndex, short x) throws SQLException;

   public void setInt(int parameterIndex, int x) throws SQLException;

   public void setLong(int parameterIndex, long x) throws SQLException;

   

   

   public void setString(int parameterIndex, String x) throws SQLException;

   public void setBytes(int parameterIndex, byte[] x) throws SQLException;

   public void setDate(int parameterIndex, Date x) throws SQLException;

   public void setTime(int parameterIndex, Time x) throws SQLException;

   public void setTimestamp(int parameterIndex, Timestamp x) throws SQLException;

   public void setAsciiStream(int parameterIndex, InputStream x, int length)
      throws SQLException;

   public void setUnicodeStream(int parameterIndex, InputStream x, int length)
      throws SQLException;

   public void setBinaryStream(int parameterIndex, InputStream x, int length)
      throws SQLException;

   public void clearParameters() throws SQLException;

   public void setObject(int parameterIndex, Object x, int targetSqlType, int scale)
      throws SQLException;

   public void setObject(int parameterIndex, Object x, int targetSqlType) 
      throws SQLException;

   public void setObject(int parameterIndex, Object x) throws SQLException;

   public boolean execute() throws SQLException;

   public void addBatch() throws SQLException;

//   public void setCharacterStream(int parameterIndex, Reader reader, int length)
//      throws SQLException;

   public void setRef(int i, Ref x) throws SQLException;

   public void setBlob(int i, Blob x) throws SQLException;

   public void setClob(int i, Clob x) throws SQLException;

   public void setArray(int i, Array x) throws SQLException;

   public ResultSetMetaData getMetaData() throws SQLException;

// public void setDate(int parameterIndex, Date x, Calendar cal) throws SQLException;

//   public void setTime(int parameterIndex, Time x, Calendar cal) throws SQLException;

//   public void setTimestamp(int parameterIndex, Timestamp x, Calendar cal)
//      throws SQLException;

   public void setNull(int paramIndex, int sqlType, String typeName) throws SQLException;

}

