package java.sql;

/* 
 * Licensed Materials - Property of IBM,
 * (c) Copyright IBM Corp. 1998, 2000 All Rights Reserved
 */

public class SQLException extends java.lang.Exception {

   private String SQLState;
   private int vendorCode;
   private SQLException next;

   public SQLException()
   {
      this(null, null, 0);
   }

   public SQLException(String reason)
   {
      this(reason, null, 0);
   }

   public SQLException(String reason, String SQLState)
   {
      this(reason, SQLState, 0);
   }

   public SQLException(String reason, String SQLState, int vendorCode)
   {
      super(reason);

      this.SQLState   = SQLState;
      this.vendorCode = vendorCode;
      this.next       = null;

      if (!(this instanceof SQLWarning) && !(this instanceof BatchUpdateException))
      {
/*
         DriverManager.println("SQLException:  reason=" + reason + 
                               " SQLState= " + SQLState + 
                               " vendor code=" + vendorCode);
*/
      }
   }

   public int getErrorCode()
   {
      return vendorCode;
   }

   public SQLException getNextException()
   {
      return next;
   }

   public String getSQLState()
   {
      return SQLState;
   }

   public synchronized void setNextException(SQLException ex)
   {
      SQLException tail = null;

      for (tail = this; tail.next != null; tail = tail.next) 
         ;
      tail.next = ex;
   }

}




