package java.sql;

/* 
 * Licensed Materials - Property of IBM,
 * (c) Copyright IBM Corp. 1998, 2000 All Rights Reserved
 */

// import java.math.BigDecimal;
import java.io.InputStream;
// import java.io.Reader;

public interface SQLInput {

   public String readString() throws SQLException;

   public boolean readBoolean() throws SQLException;

   public byte readByte() throws SQLException;

   public short readShort() throws SQLException;

   public int readInt() throws SQLException;

   public long readLong() throws SQLException;

   public float readFloat() throws SQLException;

   public double readDouble() throws SQLException;

//   public BigDecimal readBigDecimal() throws SQLException;

   public byte[] readBytes() throws SQLException;

   public Date readDate() throws SQLException;

   public Time readTime() throws SQLException;

   public Timestamp readTimestamp() throws SQLException;

//   public Reader readCharacterStream() throws SQLException;

   public InputStream readAsciiStream() throws SQLException;

   public InputStream readBinaryStream() throws SQLException;

   public Object readObject() throws SQLException;

   public Ref readRef() throws SQLException;

   public Blob readBlob() throws SQLException;

   public Clob readClob() throws SQLException;

   public Array readArray() throws SQLException;

   public boolean wasNull() throws SQLException;

}

