package java.sql;

/* 
 * Licensed Materials - Property of IBM,
 * (c) Copyright IBM Corp. 1998, 2000 All Rights Reserved
 */

import java.util.Calendar;

public class Time extends java.util.Date {

   

   public Time(long time)
   {
      super(time);
   }

   public void setTime(long time)
   {
      super.setTime(time);
   }

   public static Time valueOf(String s)
   {
      int posDelim1, posDelim2;
      int hour, minute, second;
      String errMsg = "Time must be of the form:  hh:mm:ss";

      if (s == null || (s.length() > "hh:mm:ss".length()))
         throw new java.lang.IllegalArgumentException(errMsg);

      posDelim1 = s.indexOf(':',0);
      posDelim2 = s.lastIndexOf(':');
      
      if ( (posDelim1 > 0) && (posDelim2 != s.length()-1) && ((posDelim2-posDelim1) > 1) )
      {
         hour   = Integer.parseInt(s.substring(0, posDelim1));
         minute = Integer.parseInt(s.substring(posDelim1+1, posDelim2));
         second = Integer.parseInt(s.substring(posDelim2+1));
	   Calendar cal = Calendar.getInstance();
	   cal.set( Calendar.HOUR_OF_DAY, hour);
	   cal.set( Calendar.MINUTE, minute);
	   cal.set( Calendar.SECOND, second);
   	   java.util.Date aDate = cal.getTime();
	   return new java.sql.Time(aDate.getTime());
      }

      throw new java.lang.IllegalArgumentException(errMsg);
   }

   public String toString()
   {
   	Calendar cal = Calendar.getInstance();
   	cal.setTime( this);
      int hour         = cal.get(Calendar.HOUR_OF_DAY);
      int minute       = cal.get(Calendar.MINUTE);
      int second       = cal.get(Calendar.SECOND);
      String theHour   = (hour >= 10)? (Integer.toString(hour)): ("0"+hour);
      String theMinute = (minute >= 10)? (Integer.toString(minute)): ("0"+minute);
      String theSecond = (second >= 10)? (Integer.toString(second)): ("0"+second);

      return ( theHour + ":" + theMinute + ":" + theSecond );
   }

   public int getYear()
   {
      throw new java.lang.IllegalArgumentException();
   }

   public int getMonth()
   {
      throw new java.lang.IllegalArgumentException();
   }

   public int getDay()
   {
      throw new java.lang.IllegalArgumentException();
   }

   public int getDate()
   {
      throw new java.lang.IllegalArgumentException();
   }

   public void setYear(int i)
   {
      throw new java.lang.IllegalArgumentException();
   }

   public void setMonth(int i)
   {
      throw new java.lang.IllegalArgumentException();
   }

   public void setDate(int i)
   {
      throw new java.lang.IllegalArgumentException();
   }

}

