package java.sql;

/* 
 * Licensed Materials - Property of IBM,
 * (c) Copyright IBM Corp. 1998, 2000 All Rights Reserved
 */

public class BatchUpdateException extends SQLException {

   private int[] updateCounts;

   public BatchUpdateException()
   {
      this(null, null, 0, null);
   }

   public BatchUpdateException(String reason, int[] updateCounts)
   {
      this(reason, null, 0, updateCounts);
   }

   public BatchUpdateException(String reason, String SQLState, int[] updateCounts)
   {
      this(reason, SQLState, 0, updateCounts);
   }

   public BatchUpdateException(String reason, String SQLState, int vendorCode, int[] updateCounts)
   {
      super(reason, SQLState, vendorCode);
      this.updateCounts = updateCounts;
/*
      DriverManager.println("BatchUpdateException:  reason=" + reason +
                            " SQLState=" + SQLState + 
                            " vendor code=" + vendorCode);
*/
   }

   public int[] getUpdateCounts()
   {
      return updateCounts;
   }

}

