package java.sql;

/* 
 * Licensed Materials - Property of IBM,
 * (c) Copyright IBM Corp. 1998, 2000 All Rights Reserved
 */

public class Date extends java.util.Date {

   public Date(int year, int month, int day)
   {
      super(year, month, day);

      if (month < 0 || month > 11 || day < 1 || day > 31)
            throw new java.lang.IllegalArgumentException();

   }

   public Date(long date)
   {
      super(date);
   }

   public void setTime(long date)
   {
      super.setTime(date);
   }

   public static Date valueOf(String s)
   {
      int posDelim1, posDelim2;
      int year, month, day;
      String errMsg = "Date must be of the form:  yyyy-mm-dd";
      
      if (s == null || (s.length() > "yyyy-mm-dd".length()))
         throw new java.lang.IllegalArgumentException(errMsg);

      posDelim1 = s.indexOf('-',0);
      posDelim2 = s.lastIndexOf('-');

      if ( (posDelim1 > 0) && (posDelim2 != s.length()-1) && ((posDelim2-posDelim1) > 1) )
      {
         year  = Integer.parseInt(s.substring(0, posDelim1));
         month = Integer.parseInt(s.substring(posDelim1+1, posDelim2));
         day   = Integer.parseInt(s.substring(posDelim2+1));

         return new Date(year, month, day);
      }

      throw new java.lang.IllegalArgumentException(errMsg);
   }

   public String toString()
   {
      int year        = super.getYear(); // + 1900;
      int month       = super.getMonth(); // + 1;
      int day         = super.getDate();
      String theYear  = Integer.toString(year);
      String theMonth = (month >= 10)? (Integer.toString(month)): ("0"+month);
      String theDay   = (day >= 10)? (Integer.toString(day)): ("0"+day);

      return ( theYear + "-" + theMonth + "-" + theDay );

   }

   public int getHours()
   {
      throw new java.lang.IllegalArgumentException();
   }

   public int getMinutes()
   {
      throw new java.lang.IllegalArgumentException();
   }

   public int getSeconds()
   {
      throw new java.lang.IllegalArgumentException();
   }

   public void setHours(int i)
   {
      throw new java.lang.IllegalArgumentException();
   }

   public void setMinutes(int i)
   {
      throw new java.lang.IllegalArgumentException();
   }

   public void setSeconds(int i)
   {
      throw new java.lang.IllegalArgumentException();
   }

}

