
import java.sql.*; //Step 1

class DB2eAppl{
	public static void main(String [] args){

		String driver = "com.ibm.db2e.jdbc.DB2eDriver";
		String url    = "jdbc:db2e:mysample";		
		try{
			Class.forName(driver); //Step 2
			Connection con = DriverManager.getConnection(url); //Step 3
			Statement st = con.createStatement(); //Step 4
			
			//Create table: employee  //Step 5
			st.executeUpdate("CREATE TABLE employee" +
				"(EMPNO		CHAR(6) ," +
				" FIRSTNAME VARCHAR(12) )" );
			System.out.println("***Table: employee created");
		
			//Add records to employee  
			st.executeUpdate("INSERT INTO employee VALUES ('112233','John')");
			st.executeUpdate("INSERT INTO employee VALUES ('445566','Mary')");
			System.out.println("***Two records added");
		
			//Query and display results //Step 6
			ResultSet rs = st.executeQuery("SELECT * FROM employee");
			System.out.println("***Results from table employee : ");
			while ( rs.next() ){
				System.out.print("\n EMPNO= " + rs.getString(1) + ",");
				System.out.print(" FIRSTNAME= " + rs.getString(2) );
			}
			
			//Remvove table: employee  //Step 7
			st.executeUpdate("Drop table employee");
			System.out.println("\n***Table: employee deleted ");

			rs.close();
			st.close();
			con.close();
		}catch (SQLException sqlEx){
			while(sqlEx != null){
				System.out.println("SQLERROR: \n" + sqlEx.getErrorCode() + 
						", SQLState: " + sqlEx.getSQLState() + 
						", Message: " + sqlEx.getMessage() +
						", Vendor: " + sqlEx.getErrorCode() );
				sqlEx = sqlEx.getNextException();
			}
		}catch (Exception ex){
			ex.printStackTrace();
		}
	} 
}
