#include "LView.h"


/**-----------------------------------------------------------------------------
   Purposes  :	Add Column to List View
   Input:                                                              
     ...
   Output:                                                              
     ...
   On error:                                                              
     ...Nothing                                                             
------------------------------------------------------------------------------*/
/**-----------------------------------------------------------------------------
--------------------------------------------------------------------------------
   Algorithm :                                                              
     1-/                                              
   Data Structure Usage :                                                   
     1-/                                                                
------------------------------------------------------------------------------*/
void AddColumn(HWND hwndLView, LPTSTR szText, int nCol, int nWidth)
{
	LVCOLUMN lvc;

	lvc.mask		= LVCF_TEXT|LVCF_WIDTH|LVCF_FMT|LVCF_SUBITEM;
	lvc.fmt			= LVCFMT_LEFT;
	lvc.cx			= nWidth;
	lvc.pszText		= szText;
	lvc.iSubItem	= nCol;
	lvc.cchTextMax	= DB2e_MAX_COLUMN_NAME_SIZE + 1;
	SendMessage(hwndLView, LVM_INSERTCOLUMN, nCol, (LPARAM)&lvc);

	return;
}/*End of AddColumn*/

/**-----------------------------------------------------------------------------
   Purposes  : Add Item to List View
   Input:                                                              
     ...
   Output:                                                              
     ...
   On error:                                                              
     ...Nothing                                                             
------------------------------------------------------------------------------*/
/**-----------------------------------------------------------------------------
--------------------------------------------------------------------------------
   Algorithm :                                                              
     1-/                                              
   Data Structure Usage :                                                   
     1-/                                                                
------------------------------------------------------------------------------*/
void AddItem(HWND hwndLView, LPTSTR szName, int length)
{
	LVITEM lvi;
	int count = ListView_GetItemCount(hwndLView);

	lvi.mask		= LVIF_TEXT|LVIF_PARAM;
	lvi.iItem		= count;
	lvi.iSubItem	= 0;
	lvi.pszText		= szName;
	lvi.iImage		= 0;
	lvi.cchTextMax	= length;
	//lvi.lParam		= nRow;
	SendMessage(hwndLView, LVM_INSERTITEM, 0, (LPARAM)&lvi);

	return;
}/*End of AddItem*/
